---
title: MediaStream.onremovetrack
slug: Web/API/MediaStream/onremovetrack
tags:
  - API
  - Event Handler
  - Media Streams API
  - MediaStream
  - Property
  - Reference
  - onremovetrack
---
<p>{{APIRef("Media Streams API")}}</p>

<p><span class="seoSummary">The <strong><code>MediaStream.onremovetrack</code></strong> property is an {{domxref("EventHandler")}} which specifies a function to be called when the {{event("removetrack")}} event occurs on a {{domxref("MediaStream")}} instance. This happens when a track of any kind is removed from the media stream.</span> This event is fired when the browser removes a track from the stream (such as when a {{domxref("RTCPeerConnection")}} is renegotiated or a stream being captured using {{domxref("HTMLMediaElement.captureStream()")}} gets a new set of tracks because the media element being captured loaded a new source.</p>

<p>The <code>removetrack</code> event does <em>not</em> get fired when JavaScript code explicitly removes tracks from the stream (by calling {{domxref("MediaStream.removeTrack", "removeTrack()")}}).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>MediaStream</em>.onremovetrack = <em>eventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>This should be set to a function which you provide that accepts as input a {{domxref("MediaStreamTrackEvent")}} object representing the {{event("removetrack")}} event which has occurred. The {{domxref("MediaStreamTrack")}} representing the track which was removed is specified in the event's {{domxref("MediaStreamTrackEvent.track", "track")}} property.</p>

<h2 id="Example">Example</h2>

<p>This example adds a listener which, when a track is removed from the stream, logs the track that was removed.</p>

<pre class="brush: js notranslate">stream.onremovetrack = function(event) {
  let trackList = document.getElementById("tracks");
  let label = document.createElement("li");

  label.textContent = `Removed: ${event.track.kind}: ${event.track.label}`;
  trackList.appendChild(label);
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#dom-mediastream-onremovetrack', 'MediaStream.onremovetrack') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaStream.onremovetrack")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("removetrack")}} event and its type, {{domxref("MediaStreamTrackEvent")}}.</li>
</ul>
